#include "dac_driver.h"


void initDac(void)
{
	DAC_DualChannel_Enable( &DACB,
	                        DAC_REFSEL_AVCC_gc,
	                        false,
	                        DAC_CONINTVAL_4CLK_gc,
	                        DAC_REFRESH_32CLK_gc );
}
void dac0Out(uint16_t wert)
{
	while ( DAC_Channel_DataEmpty( &DACB, CH0 ) == false ) {
		/* Blocking code waiting for empty register. */
	}
	DAC_Channel_Write( &DACB, wert, CH0 );
}
void dac1Out(uint16_t wert)
{
	while ( DAC_Channel_DataEmpty( &DACB, CH1 ) == false ) {
		/* Blocking code waiting for empty register. */
	}
	DAC_Channel_Write( &DACB, wert, CH1 );
}


int main( void )
{
    PORTQ.DIR = 0B00001000; //amplifier
	PORTQ.OUT = 0b00001000; //ENABLE AUDIO ON XPLAIN

	PORTE.DIR = 0xFF; // led port
	PORTE.OUT = 0xFF; // leds low active, turn leds off


	PORTE.OUT ^= (1<<0); // toggle LED

	initDac();
	dac1Out(2048);

	uint32_t frequenz=440; // frequenz in Hz
	uint16_t amplitude=50; // von 0 .. 2047

	while(1)
	{

			_delay_us(1000000UL/frequenz/2);

			dac0Out(2048-amplitude);
			_delay_us(1000000UL/frequenz/2);
			dac0Out(2048+amplitude);
	}

}
